<?php
/**
 * topapi
 *
 * -- category.itemCategory
 * -- 获取平台分类树
 *
 * @copyright  Copyright (c) 2005-2016 ShopEx Technologies Inc. (http://www.shopex.cn)
 * @license  http://ecos.shopex.cn/ ShopEx License
 */
class topapi_api_v1_category_itemCategory implements topapi_interface_api {

    /**
     * 接口作用说明
     */
    public $apiDescription = '获取平台分类树';

    /**
     * 定义API传入的应用级参数
     * @desc 用于在调用接口前，根据定义的参数，过滤必填参数是否已经参入，并且定义参数的数据类型，参数是否必填，参数的描述
     * @return array 返回传入参数
     */
    public function setParams()
    {
        return [];
    }

    public function handle($params)
    {
        $pagedata['categorys'] =app::get('topapi')->rpcCall('category.cat.get.list');
        return $pagedata;
    }

    /**
     * 返回json格式的例子
     * @return string 结果json串
     */
    public function returnJson()
    {
        return '{"errorcode":0,"msg":"","data":{"categorys":[{"cat_id":1,"parent_id":0,"cat_name":"服装鞋包","cat_logo":"","cat_path":",","level":"1","is_leaf":0,"child_count":6,"order_sort":0,"lv2":[{"cat_id":2,"parent_id":1,"cat_name":"女装","cat_logo":null,"cat_path":",1,","level":"2","is_leaf":0,"child_count":13,"order_sort":0,"lv3":[{"cat_id":33,"parent_id":2,"cat_name":"连衣裙","cat_logo":null,"cat_path":",1,2,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":34,"parent_id":2,"cat_name":"外套","cat_logo":null,"cat_path":",1,2,","level":"3","is_leaf":1,"child_count":0,"order_sort":2},{"cat_id":35,"parent_id":2,"cat_name":"羽绒服","cat_logo":null,"cat_path":",1,2,","level":"3","is_leaf":1,"child_count":0,"order_sort":3},{"cat_id":36,"parent_id":2,"cat_name":"羊绒衫","cat_logo":null,"cat_path":",1,2,","level":"3","is_leaf":1,"child_count":0,"order_sort":4},{"cat_id":37,"parent_id":2,"cat_name":"卫衣","cat_logo":null,"cat_path":",1,2,","level":"3","is_leaf":1,"child_count":0,"order_sort":5},{"cat_id":38,"parent_id":2,"cat_name":"棉服","cat_logo":null,"cat_path":",1,2,","level":"3","is_leaf":1,"child_count":0,"order_sort":6},{"cat_id":39,"parent_id":2,"cat_name":"打底衫","cat_logo":null,"cat_path":",1,2,","level":"3","is_leaf":1,"child_count":0,"order_sort":7},{"cat_id":40,"parent_id":2,"cat_name":"T恤","cat_logo":null,"cat_path":",1,2,","level":"3","is_leaf":1,"child_count":0,"order_sort":8},{"cat_id":41,"parent_id":2,"cat_name":"小西服","cat_logo":null,"cat_path":",1,2,","level":"3","is_leaf":1,"child_count":0,"order_sort":9},{"cat_id":42,"parent_id":2,"cat_name":"休闲裤","cat_logo":null,"cat_path":",1,2,","level":"3","is_leaf":1,"child_count":0,"order_sort":10},{"cat_id":43,"parent_id":2,"cat_name":"牛仔裤","cat_logo":null,"cat_path":",1,2,","level":"3","is_leaf":1,"child_count":0,"order_sort":11},{"cat_id":44,"parent_id":2,"cat_name":"短裤","cat_logo":null,"cat_path":",1,2,","level":"3","is_leaf":1,"child_count":0,"order_sort":12},{"cat_id":45,"parent_id":2,"cat_name":"裙子","cat_logo":null,"cat_path":",1,2,","level":"3","is_leaf":1,"child_count":0,"order_sort":13}]},{"cat_id":3,"parent_id":1,"cat_name":"男装","cat_logo":null,"cat_path":",1,","level":"2","is_leaf":0,"child_count":8,"order_sort":1,"lv3":[{"cat_id":27,"parent_id":3,"cat_name":"西服","cat_logo":null,"cat_path":",1,3,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":28,"parent_id":3,"cat_name":"卫衣","cat_logo":null,"cat_path":",1,3,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":29,"parent_id":3,"cat_name":"外套","cat_logo":null,"cat_path":",1,3,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":30,"parent_id":3,"cat_name":"棉衣","cat_logo":null,"cat_path":",1,3,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":31,"parent_id":3,"cat_name":"针织衫","cat_logo":null,"cat_path":",1,3,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":379,"parent_id":3,"cat_name":"裤装","cat_logo":null,"cat_path":",1,3,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":399,"parent_id":3,"cat_name":"衬衫","cat_logo":null,"cat_path":",1,3,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":400,"parent_id":3,"cat_name":"内衣裤","cat_logo":null,"cat_path":",1,3,","level":"3","is_leaf":1,"child_count":0,"order_sort":0}]},{"cat_id":4,"parent_id":1,"cat_name":"男包","cat_logo":null,"cat_path":",1,","level":"2","is_leaf":0,"child_count":6,"order_sort":2,"lv3":[{"cat_id":71,"parent_id":4,"cat_name":"商务包","cat_logo":null,"cat_path":",1,4,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":72,"parent_id":4,"cat_name":"单肩包","cat_logo":null,"cat_path":",1,4,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":73,"parent_id":4,"cat_name":"双肩包","cat_logo":null,"cat_path":",1,4,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":74,"parent_id":4,"cat_name":"钱包","cat_logo":null,"cat_path":",1,4,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":75,"parent_id":4,"cat_name":"运动背包","cat_logo":null,"cat_path":",1,4,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":76,"parent_id":4,"cat_name":"公文包","cat_logo":null,"cat_path":",1,4,","level":"3","is_leaf":1,"child_count":0,"order_sort":0}]},{"cat_id":5,"parent_id":1,"cat_name":"女包","cat_logo":null,"cat_path":",1,","level":"2","is_leaf":0,"child_count":5,"order_sort":3,"lv3":[{"cat_id":77,"parent_id":5,"cat_name":"手提包","cat_logo":null,"cat_path":",1,5,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":78,"parent_id":5,"cat_name":"单肩包","cat_logo":null,"cat_path":",1,5,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":79,"parent_id":5,"cat_name":"双肩包","cat_logo":null,"cat_path":",1,5,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":80,"parent_id":5,"cat_name":"钱包","cat_logo":null,"cat_path":",1,5,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":81,"parent_id":5,"cat_name":"卡包/零钱包","cat_logo":null,"cat_path":",1,5,","level":"3","is_leaf":1,"child_count":0,"order_sort":0}]},{"cat_id":377,"parent_id":1,"cat_name":"女鞋","cat_logo":null,"cat_path":",1,","level":"2","is_leaf":0,"child_count":1,"order_sort":4,"lv3":[{"cat_id":378,"parent_id":377,"cat_name":"休闲鞋","cat_logo":null,"cat_path":",1,377,","level":"3","is_leaf":1,"child_count":0,"order_sort":0}]},{"cat_id":376,"parent_id":1,"cat_name":"男鞋","cat_logo":null,"cat_path":",1,","level":"2","is_leaf":0,"child_count":2,"order_sort":5,"lv3":[{"cat_id":387,"parent_id":376,"cat_name":"休闲鞋","cat_logo":null,"cat_path":",1,376,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":401,"parent_id":376,"cat_name":"运动鞋","cat_logo":null,"cat_path":",1,376,","level":"3","is_leaf":1,"child_count":0,"order_sort":0}]}]},{"cat_id":6,"parent_id":0,"cat_name":"家用电器","cat_logo":"","cat_path":",","level":"1","is_leaf":0,"child_count":5,"order_sort":1,"lv2":[{"cat_id":7,"parent_id":6,"cat_name":"大家电","cat_logo":null,"cat_path":",6,","level":"2","is_leaf":0,"child_count":5,"order_sort":0,"lv3":[{"cat_id":82,"parent_id":7,"cat_name":"平板电视","cat_logo":null,"cat_path":",6,7,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":83,"parent_id":7,"cat_name":"空调","cat_logo":null,"cat_path":",6,7,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":84,"parent_id":7,"cat_name":"冰箱/酒柜","cat_logo":null,"cat_path":",6,7,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":85,"parent_id":7,"cat_name":"洗衣机","cat_logo":null,"cat_path":",6,7,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":86,"parent_id":7,"cat_name":"家庭影院","cat_logo":null,"cat_path":",6,7,","level":"3","is_leaf":1,"child_count":0,"order_sort":0}]},{"cat_id":8,"parent_id":6,"cat_name":"生活电器","cat_logo":null,"cat_path":",6,","level":"2","is_leaf":0,"child_count":7,"order_sort":1,"lv3":[{"cat_id":87,"parent_id":8,"cat_name":"吸尘器","cat_logo":null,"cat_path":",6,8,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":88,"parent_id":8,"cat_name":"取暖电器","cat_logo":null,"cat_path":",6,8,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":89,"parent_id":8,"cat_name":"热水器","cat_logo":null,"cat_path":",6,8,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":90,"parent_id":8,"cat_name":"电风扇","cat_logo":null,"cat_path":",6,8,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":91,"parent_id":8,"cat_name":"除湿机","cat_logo":null,"cat_path":",6,8,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":92,"parent_id":8,"cat_name":"电话机","cat_logo":null,"cat_path":",6,8,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":93,"parent_id":8,"cat_name":"净化器","cat_logo":null,"cat_path":",6,8,","level":"3","is_leaf":1,"child_count":0,"order_sort":0}]},{"cat_id":9,"parent_id":6,"cat_name":"厨房电器","cat_logo":null,"cat_path":",6,","level":"2","is_leaf":0,"child_count":10,"order_sort":2,"lv3":[{"cat_id":95,"parent_id":9,"cat_name":"电压力锅","cat_logo":null,"cat_path":",6,9,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":96,"parent_id":9,"cat_name":"电饭煲","cat_logo":null,"cat_path":",6,9,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":97,"parent_id":9,"cat_name":"豆浆机","cat_logo":null,"cat_path":",6,9,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":98,"parent_id":9,"cat_name":"面包机","cat_logo":null,"cat_path":",6,9,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":99,"parent_id":9,"cat_name":"咖啡机","cat_logo":null,"cat_path":",6,9,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":100,"parent_id":9,"cat_name":"电烤箱","cat_logo":null,"cat_path":",6,9,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":101,"parent_id":9,"cat_name":"洗碗机/消毒柜","cat_logo":null,"cat_path":",6,9,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":102,"parent_id":9,"cat_name":"吸油烟机","cat_logo":null,"cat_path":",6,9,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":103,"parent_id":9,"cat_name":"电水壶","cat_logo":null,"cat_path":",6,9,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":104,"parent_id":9,"cat_name":"榨汁机","cat_logo":null,"cat_path":",6,9,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]},{"cat_id":10,"parent_id":6,"cat_name":"个护健康","cat_logo":null,"cat_path":",6,","level":"2","is_leaf":0,"child_count":5,"order_sort":3,"lv3":[{"cat_id":105,"parent_id":10,"cat_name":"按摩椅","cat_logo":null,"cat_path":",6,10,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":106,"parent_id":10,"cat_name":"口腔护理","cat_logo":null,"cat_path":",6,10,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":107,"parent_id":10,"cat_name":"电吹风","cat_logo":null,"cat_path":",6,10,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":108,"parent_id":10,"cat_name":"美容器","cat_logo":null,"cat_path":",6,10,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":109,"parent_id":10,"cat_name":"理发器","cat_logo":null,"cat_path":",6,10,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]},{"cat_id":11,"parent_id":6,"cat_name":"五金家族","cat_logo":null,"cat_path":",6,","level":"2","is_leaf":0,"child_count":6,"order_sort":4,"lv3":[{"cat_id":110,"parent_id":11,"cat_name":"灯具","cat_logo":null,"cat_path":",6,11,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":111,"parent_id":11,"cat_name":"浴霸/排气扇","cat_logo":null,"cat_path":",6,11,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":112,"parent_id":11,"cat_name":"仪器仪表","cat_logo":null,"cat_path":",6,11,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":113,"parent_id":11,"cat_name":"手动工具","cat_logo":null,"cat_path":",6,11,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":114,"parent_id":11,"cat_name":"电动工具","cat_logo":null,"cat_path":",6,11,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":115,"parent_id":11,"cat_name":"LED灯","cat_logo":null,"cat_path":",6,11,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]}]},{"cat_id":12,"parent_id":0,"cat_name":"手机数码","cat_logo":"","cat_path":",","level":"1","is_leaf":0,"child_count":4,"order_sort":2,"lv2":[{"cat_id":13,"parent_id":12,"cat_name":"手机通讯","cat_logo":null,"cat_path":",12,","level":"2","is_leaf":0,"child_count":3,"order_sort":0,"lv3":[{"cat_id":22,"parent_id":13,"cat_name":"智能手机","cat_logo":null,"cat_path":",12,13,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":116,"parent_id":13,"cat_name":"非智能手机","cat_logo":null,"cat_path":",12,13,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":395,"parent_id":13,"cat_name":"智能设备","cat_logo":null,"cat_path":",12,13,","level":"3","is_leaf":1,"child_count":0,"order_sort":0}]},{"cat_id":123,"parent_id":12,"cat_name":"数码配件","cat_logo":null,"cat_path":",12,","level":"2","is_leaf":0,"child_count":6,"order_sort":1,"lv3":[{"cat_id":124,"parent_id":123,"cat_name":"三脚架","cat_logo":null,"cat_path":",12,123,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":125,"parent_id":123,"cat_name":"储存卡","cat_logo":null,"cat_path":",12,123,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":126,"parent_id":123,"cat_name":"读卡器","cat_logo":null,"cat_path":",12,123,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":127,"parent_id":123,"cat_name":"三脚架/云台","cat_logo":null,"cat_path":",12,123,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":128,"parent_id":123,"cat_name":"相机电池","cat_logo":null,"cat_path":",12,123,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":129,"parent_id":123,"cat_name":"相机清洁/贴膜","cat_logo":null,"cat_path":",12,123,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]},{"cat_id":21,"parent_id":12,"cat_name":"影音娱乐","cat_logo":null,"cat_path":",12,","level":"2","is_leaf":0,"child_count":8,"order_sort":2,"lv3":[{"cat_id":63,"parent_id":21,"cat_name":"电脑","cat_logo":null,"cat_path":",12,21,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":64,"parent_id":21,"cat_name":"平板","cat_logo":null,"cat_path":",12,21,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":65,"parent_id":21,"cat_name":"打印","cat_logo":null,"cat_path":",12,21,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":117,"parent_id":21,"cat_name":"耳机/耳麦","cat_logo":null,"cat_path":",12,21,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":118,"parent_id":21,"cat_name":"音箱/音响","cat_logo":null,"cat_path":",12,21,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":119,"parent_id":21,"cat_name":"MP3/MP4","cat_logo":null,"cat_path":",12,21,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":120,"parent_id":21,"cat_name":"专业音频","cat_logo":null,"cat_path":",12,21,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":121,"parent_id":21,"cat_name":"苹果周边","cat_logo":null,"cat_path":",12,21,","level":"3","is_leaf":1,"child_count":0,"order_sort":0}]},{"cat_id":122,"parent_id":12,"cat_name":"摄影摄像","cat_logo":null,"cat_path":",12,","level":"2","is_leaf":0,"child_count":6,"order_sort":2,"lv3":[{"cat_id":130,"parent_id":122,"cat_name":"单电/微单","cat_logo":null,"cat_path":",12,122,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":131,"parent_id":122,"cat_name":"单反相机","cat_logo":null,"cat_path":",12,122,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":132,"parent_id":122,"cat_name":"数码相机","cat_logo":null,"cat_path":",12,122,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":133,"parent_id":122,"cat_name":"摄像机","cat_logo":null,"cat_path":",12,122,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":134,"parent_id":122,"cat_name":"镜头","cat_logo":null,"cat_path":",12,122,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":135,"parent_id":122,"cat_name":"拍立得","cat_logo":null,"cat_path":",12,122,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]}]},{"cat_id":14,"parent_id":0,"cat_name":"电脑、办公","cat_logo":"","cat_path":",","level":"1","is_leaf":0,"child_count":6,"order_sort":3,"lv2":[{"cat_id":15,"parent_id":14,"cat_name":"电脑整机","cat_logo":null,"cat_path":",14,","level":"2","is_leaf":0,"child_count":3,"order_sort":0,"lv3":[{"cat_id":24,"parent_id":15,"cat_name":"笔记本","cat_logo":null,"cat_path":",14,15,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":23,"parent_id":15,"cat_name":"平板电脑","cat_logo":null,"cat_path":",14,15,","level":"3","is_leaf":1,"child_count":0,"order_sort":2},{"cat_id":25,"parent_id":15,"cat_name":"台式机","cat_logo":null,"cat_path":",14,15,","level":"3","is_leaf":1,"child_count":0,"order_sort":3}]},{"cat_id":16,"parent_id":14,"cat_name":"电脑配件","cat_logo":null,"cat_path":",14,","level":"2","is_leaf":0,"child_count":9,"order_sort":1,"lv3":[{"cat_id":136,"parent_id":16,"cat_name":"CPU","cat_logo":null,"cat_path":",14,16,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":137,"parent_id":16,"cat_name":"主板","cat_logo":null,"cat_path":",14,16,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":138,"parent_id":16,"cat_name":"内存","cat_logo":null,"cat_path":",14,16,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":139,"parent_id":16,"cat_name":"硬盘","cat_logo":null,"cat_path":",14,16,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":140,"parent_id":16,"cat_name":"SSD固态硬盘","cat_logo":null,"cat_path":",14,16,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":141,"parent_id":16,"cat_name":"显卡","cat_logo":null,"cat_path":",14,16,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":142,"parent_id":16,"cat_name":"机箱","cat_logo":null,"cat_path":",14,16,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":143,"parent_id":16,"cat_name":"相电源","cat_logo":null,"cat_path":",14,16,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":144,"parent_id":16,"cat_name":"相光驱","cat_logo":null,"cat_path":",14,16,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]},{"cat_id":17,"parent_id":14,"cat_name":"网络产品","cat_logo":null,"cat_path":",14,","level":"2","is_leaf":0,"child_count":8,"order_sort":3,"lv3":[{"cat_id":145,"parent_id":17,"cat_name":"4G/3G上网","cat_logo":null,"cat_path":",14,17,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":146,"parent_id":17,"cat_name":"网络盒子","cat_logo":null,"cat_path":",14,17,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":147,"parent_id":17,"cat_name":"网卡","cat_logo":null,"cat_path":",14,17,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":148,"parent_id":17,"cat_name":"路由器","cat_logo":null,"cat_path":",14,17,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":149,"parent_id":17,"cat_name":"交换机","cat_logo":null,"cat_path":",14,17,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":150,"parent_id":17,"cat_name":"网络存储","cat_logo":null,"cat_path":",14,17,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":151,"parent_id":17,"cat_name":"上网卡","cat_logo":null,"cat_path":",14,17,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":152,"parent_id":17,"cat_name":"网络配件","cat_logo":null,"cat_path":",14,17,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]},{"cat_id":18,"parent_id":14,"cat_name":"办公设备","cat_logo":null,"cat_path":",14,","level":"2","is_leaf":0,"child_count":9,"order_sort":4,"lv3":[{"cat_id":153,"parent_id":18,"cat_name":"打印机","cat_logo":null,"cat_path":",14,18,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":154,"parent_id":18,"cat_name":"投影设备","cat_logo":null,"cat_path":",14,18,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":155,"parent_id":18,"cat_name":"多功能一体机","cat_logo":null,"cat_path":",14,18,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":156,"parent_id":18,"cat_name":"传真机","cat_logo":null,"cat_path":",14,18,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":157,"parent_id":18,"cat_name":"扫描设备","cat_logo":null,"cat_path":",14,18,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":158,"parent_id":18,"cat_name":"考勤机","cat_logo":null,"cat_path":",14,18,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":159,"parent_id":18,"cat_name":"会议音频视频","cat_logo":null,"cat_path":",14,18,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":160,"parent_id":18,"cat_name":"保险柜","cat_logo":null,"cat_path":",14,18,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":161,"parent_id":18,"cat_name":"安防监控","cat_logo":null,"cat_path":",14,18,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]},{"cat_id":19,"parent_id":14,"cat_name":"文具耗材","cat_logo":null,"cat_path":",14,","level":"2","is_leaf":0,"child_count":9,"order_sort":5,"lv3":[{"cat_id":162,"parent_id":19,"cat_name":"文件管理","cat_logo":null,"cat_path":",14,19,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":163,"parent_id":19,"cat_name":"计算器","cat_logo":null,"cat_path":",14,19,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":164,"parent_id":19,"cat_name":"画具画材","cat_logo":null,"cat_path":",14,19,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":165,"parent_id":19,"cat_name":"墨盒","cat_logo":null,"cat_path":",14,19,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":166,"parent_id":19,"cat_name":"色带","cat_logo":null,"cat_path":",14,19,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":167,"parent_id":19,"cat_name":"办公文具","cat_logo":null,"cat_path":",14,19,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":168,"parent_id":19,"cat_name":"会议音频视频","cat_logo":null,"cat_path":",14,19,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":169,"parent_id":19,"cat_name":"财会用品","cat_logo":null,"cat_path":",14,19,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":170,"parent_id":19,"cat_name":"本册/便签","cat_logo":null,"cat_path":",14,19,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]},{"cat_id":20,"parent_id":14,"cat_name":"外设产品","cat_logo":null,"cat_path":",14,","level":"2","is_leaf":0,"child_count":9,"order_sort":6,"lv3":[{"cat_id":171,"parent_id":20,"cat_name":"电玩","cat_logo":null,"cat_path":",14,20,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":172,"parent_id":20,"cat_name":"手写板","cat_logo":null,"cat_path":",14,20,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":173,"parent_id":20,"cat_name":"外置盒","cat_logo":null,"cat_path":",14,20,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":174,"parent_id":20,"cat_name":"电脑工具","cat_logo":null,"cat_path":",14,20,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":175,"parent_id":20,"cat_name":"电脑清洁","cat_logo":null,"cat_path":",14,20,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":176,"parent_id":20,"cat_name":"UPS","cat_logo":null,"cat_path":",14,20,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":177,"parent_id":20,"cat_name":"鼠标","cat_logo":null,"cat_path":",14,20,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":178,"parent_id":20,"cat_name":"U盘","cat_logo":null,"cat_path":",14,20,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":179,"parent_id":20,"cat_name":"插座","cat_logo":null,"cat_path":",14,20,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]}]},{"cat_id":46,"parent_id":0,"cat_name":"母婴、玩具","cat_logo":"","cat_path":",","level":"1","is_leaf":0,"child_count":8,"order_sort":5,"lv2":[{"cat_id":49,"parent_id":46,"cat_name":"尿裤湿巾","cat_logo":null,"cat_path":",46,","level":"2","is_leaf":0,"child_count":2,"order_sort":1,"lv3":[{"cat_id":57,"parent_id":49,"cat_name":"婴儿尿裤","cat_logo":null,"cat_path":",46,49,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":58,"parent_id":49,"cat_name":"湿巾","cat_logo":null,"cat_path":",46,49,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]},{"cat_id":380,"parent_id":46,"cat_name":"童装、童鞋","cat_logo":null,"cat_path":",46,","level":"2","is_leaf":0,"child_count":2,"order_sort":1,"lv3":[{"cat_id":384,"parent_id":380,"cat_name":"童装","cat_logo":null,"cat_path":",46,380,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":385,"parent_id":380,"cat_name":"童鞋","cat_logo":null,"cat_path":",46,380,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]},{"cat_id":48,"parent_id":46,"cat_name":"营养辅食","cat_logo":null,"cat_path":",46,","level":"2","is_leaf":0,"child_count":7,"order_sort":2,"lv3":[{"cat_id":55,"parent_id":48,"cat_name":"果泥/果汁","cat_logo":null,"cat_path":",46,48,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":56,"parent_id":48,"cat_name":"面条/粥","cat_logo":null,"cat_path":",46,48,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":180,"parent_id":48,"cat_name":"清火/开胃","cat_logo":null,"cat_path":",46,48,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":181,"parent_id":48,"cat_name":"钙铁锌/维生素","cat_logo":null,"cat_path":",46,48,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":182,"parent_id":48,"cat_name":"DHA","cat_logo":null,"cat_path":",46,48,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":183,"parent_id":48,"cat_name":"益生菌/初乳","cat_logo":null,"cat_path":",46,48,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":184,"parent_id":48,"cat_name":"宝宝零食","cat_logo":null,"cat_path":",46,48,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]},{"cat_id":185,"parent_id":46,"cat_name":"洗护用品","cat_logo":null,"cat_path":",46,","level":"2","is_leaf":0,"child_count":8,"order_sort":2,"lv3":[{"cat_id":186,"parent_id":185,"cat_name":"理发器","cat_logo":null,"cat_path":",46,185,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":187,"parent_id":185,"cat_name":"洗衣液/皂","cat_logo":null,"cat_path":",46,185,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":188,"parent_id":185,"cat_name":"坐便器","cat_logo":null,"cat_path":",46,185,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":189,"parent_id":185,"cat_name":"驱蚊防蚊","cat_logo":null,"cat_path":",46,185,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":190,"parent_id":185,"cat_name":"宝宝洗浴","cat_logo":null,"cat_path":",46,185,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":191,"parent_id":185,"cat_name":"宝宝护肤","cat_logo":null,"cat_path":",46,185,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":192,"parent_id":185,"cat_name":"日常护理","cat_logo":null,"cat_path":",46,185,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":193,"parent_id":185,"cat_name":"奶瓶清洗","cat_logo":null,"cat_path":",46,185,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]},{"cat_id":47,"parent_id":46,"cat_name":"奶粉","cat_logo":null,"cat_path":",46,","level":"2","is_leaf":0,"child_count":2,"order_sort":3,"lv3":[{"cat_id":53,"parent_id":47,"cat_name":"婴幼奶粉","cat_logo":null,"cat_path":",46,47,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":54,"parent_id":47,"cat_name":"成人奶粉","cat_logo":null,"cat_path":",46,47,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]},{"cat_id":50,"parent_id":46,"cat_name":"喂养用品","cat_logo":null,"cat_path":",46,","level":"2","is_leaf":0,"child_count":7,"order_sort":4,"lv3":[{"cat_id":59,"parent_id":50,"cat_name":"奶嘴奶壶","cat_logo":null,"cat_path":",46,50,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":194,"parent_id":50,"cat_name":"牙胶安抚","cat_logo":null,"cat_path":",46,50,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":195,"parent_id":50,"cat_name":"辅食料理机","cat_logo":null,"cat_path":",46,50,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":196,"parent_id":50,"cat_name":"碗盘叉勺","cat_logo":null,"cat_path":",46,50,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":197,"parent_id":50,"cat_name":"水壶/水杯","cat_logo":null,"cat_path":",46,50,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":198,"parent_id":50,"cat_name":"吸奶器","cat_logo":null,"cat_path":",46,50,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":199,"parent_id":50,"cat_name":"暖奶消毒","cat_logo":null,"cat_path":",46,50,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]},{"cat_id":51,"parent_id":46,"cat_name":"玩具乐器","cat_logo":null,"cat_path":",46,","level":"2","is_leaf":0,"child_count":9,"order_sort":5,"lv3":[{"cat_id":200,"parent_id":51,"cat_name":"遥控/电动","cat_logo":null,"cat_path":",46,51,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":201,"parent_id":51,"cat_name":"适用年龄","cat_logo":null,"cat_path":",46,51,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":202,"parent_id":51,"cat_name":"毛绒布艺","cat_logo":null,"cat_path":",46,51,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":203,"parent_id":51,"cat_name":"动漫玩具","cat_logo":null,"cat_path":",46,51,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":204,"parent_id":51,"cat_name":"健身玩具","cat_logo":null,"cat_path":",46,51,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":205,"parent_id":51,"cat_name":"DIY玩具","cat_logo":null,"cat_path":",46,51,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":206,"parent_id":51,"cat_name":"乐器相关","cat_logo":null,"cat_path":",46,51,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":207,"parent_id":51,"cat_name":"娃娃玩具","cat_logo":null,"cat_path":",46,51,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":208,"parent_id":51,"cat_name":"开发智力","cat_logo":null,"cat_path":",46,51,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]},{"cat_id":52,"parent_id":46,"cat_name":"妈妈专区","cat_logo":null,"cat_path":",46,","level":"2","is_leaf":0,"child_count":9,"order_sort":6,"lv3":[{"cat_id":209,"parent_id":52,"cat_name":"妈咪包/背婴带","cat_logo":null,"cat_path":",46,52,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":210,"parent_id":52,"cat_name":"待产/新生","cat_logo":null,"cat_path":",46,52,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":211,"parent_id":52,"cat_name":"产后塑身","cat_logo":null,"cat_path":",46,52,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":212,"parent_id":52,"cat_name":"文胸/内裤","cat_logo":null,"cat_path":",46,52,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":213,"parent_id":52,"cat_name":"防辐射服","cat_logo":null,"cat_path":",46,52,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":214,"parent_id":52,"cat_name":"孕妇装","cat_logo":null,"cat_path":",46,52,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":215,"parent_id":52,"cat_name":"月子装","cat_logo":null,"cat_path":",46,52,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":216,"parent_id":52,"cat_name":"孕期营养","cat_logo":null,"cat_path":",46,52,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":217,"parent_id":52,"cat_name":"孕妈美容","cat_logo":null,"cat_path":",46,52,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]}]},{"cat_id":66,"parent_id":0,"cat_name":"个护化妆","cat_logo":"","cat_path":",","level":"1","is_leaf":0,"child_count":5,"order_sort":6,"lv2":[{"cat_id":67,"parent_id":66,"cat_name":"面部护肤","cat_logo":null,"cat_path":",66,","level":"2","is_leaf":0,"child_count":5,"order_sort":0,"lv3":[{"cat_id":218,"parent_id":67,"cat_name":"清洁","cat_logo":null,"cat_path":",66,67,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":219,"parent_id":67,"cat_name":"护肤","cat_logo":null,"cat_path":",66,67,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":220,"parent_id":67,"cat_name":"面膜","cat_logo":null,"cat_path":",66,67,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":221,"parent_id":67,"cat_name":"剃须","cat_logo":null,"cat_path":",66,67,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":222,"parent_id":67,"cat_name":"套装","cat_logo":null,"cat_path":",66,67,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]},{"cat_id":68,"parent_id":66,"cat_name":"洗发护发","cat_logo":null,"cat_path":",66,","level":"2","is_leaf":0,"child_count":6,"order_sort":0,"lv3":[{"cat_id":238,"parent_id":68,"cat_name":"造型","cat_logo":null,"cat_path":",66,68,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":239,"parent_id":68,"cat_name":"套装","cat_logo":null,"cat_path":",66,68,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":240,"parent_id":68,"cat_name":"洗发","cat_logo":null,"cat_path":",66,68,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":241,"parent_id":68,"cat_name":"染发","cat_logo":null,"cat_path":",66,68,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":242,"parent_id":68,"cat_name":"护发","cat_logo":null,"cat_path":",66,68,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":243,"parent_id":68,"cat_name":"假发","cat_logo":null,"cat_path":",66,68,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]},{"cat_id":69,"parent_id":66,"cat_name":"身体护肤","cat_logo":null,"cat_path":",66,","level":"2","is_leaf":0,"child_count":7,"order_sort":0,"lv3":[{"cat_id":231,"parent_id":69,"cat_name":"纤体塑形","cat_logo":null,"cat_path":",66,69,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":232,"parent_id":69,"cat_name":"美胸","cat_logo":null,"cat_path":",66,69,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":233,"parent_id":69,"cat_name":"润肤","cat_logo":null,"cat_path":",66,69,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":234,"parent_id":69,"cat_name":"沐浴","cat_logo":null,"cat_path":",66,69,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":235,"parent_id":69,"cat_name":"手足","cat_logo":null,"cat_path":",66,69,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":236,"parent_id":69,"cat_name":"颈部","cat_logo":null,"cat_path":",66,69,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":237,"parent_id":69,"cat_name":"套装","cat_logo":null,"cat_path":",66,69,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]},{"cat_id":70,"parent_id":66,"cat_name":"口腔护理","cat_logo":null,"cat_path":",66,","level":"2","is_leaf":0,"child_count":4,"order_sort":0,"lv3":[{"cat_id":227,"parent_id":70,"cat_name":"牙膏/牙粉","cat_logo":null,"cat_path":",66,70,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":228,"parent_id":70,"cat_name":"牙刷/牙线","cat_logo":null,"cat_path":",66,70,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":229,"parent_id":70,"cat_name":"漱口水","cat_logo":null,"cat_path":",66,70,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":230,"parent_id":70,"cat_name":"套装","cat_logo":null,"cat_path":",66,70,","level":"3","is_leaf":1,"child_count":0,"order_sort":0}]},{"cat_id":226,"parent_id":66,"cat_name":"香水彩妆","cat_logo":null,"cat_path":",66,","level":"2","is_leaf":0,"child_count":8,"order_sort":1,"lv3":[{"cat_id":246,"parent_id":226,"cat_name":"香水","cat_logo":null,"cat_path":",66,226,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":247,"parent_id":226,"cat_name":"底妆","cat_logo":null,"cat_path":",66,226,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":248,"parent_id":226,"cat_name":"腮红","cat_logo":null,"cat_path":",66,226,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":249,"parent_id":226,"cat_name":"眼部","cat_logo":null,"cat_path":",66,226,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":250,"parent_id":226,"cat_name":"唇部","cat_logo":null,"cat_path":",66,226,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":251,"parent_id":226,"cat_name":"美甲","cat_logo":null,"cat_path":",66,226,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":252,"parent_id":226,"cat_name":"套装","cat_logo":null,"cat_path":",66,226,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":253,"parent_id":226,"cat_name":"美容工具","cat_logo":null,"cat_path":",66,226,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]}]},{"cat_id":254,"parent_id":0,"cat_name":"食品、生鲜","cat_logo":"","cat_path":",","level":"1","is_leaf":0,"child_count":6,"order_sort":7,"lv2":[{"cat_id":396,"parent_id":254,"cat_name":"酒水饮料","cat_logo":null,"cat_path":",254,","level":"2","is_leaf":0,"child_count":2,"order_sort":0,"lv3":[{"cat_id":397,"parent_id":396,"cat_name":"酒类","cat_logo":null,"cat_path":",254,396,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":398,"parent_id":396,"cat_name":"饮料","cat_logo":null,"cat_path":",254,396,","level":"3","is_leaf":1,"child_count":0,"order_sort":0}]},{"cat_id":255,"parent_id":254,"cat_name":"地方特产","cat_logo":null,"cat_path":",254,","level":"2","is_leaf":0,"child_count":9,"order_sort":1,"lv3":[{"cat_id":260,"parent_id":255,"cat_name":"新疆","cat_logo":null,"cat_path":",254,255,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":261,"parent_id":255,"cat_name":"四川","cat_logo":null,"cat_path":",254,255,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":262,"parent_id":255,"cat_name":"云南","cat_logo":null,"cat_path":",254,255,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":263,"parent_id":255,"cat_name":"湖南","cat_logo":null,"cat_path":",254,255,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":264,"parent_id":255,"cat_name":"内蒙","cat_logo":null,"cat_path":",254,255,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":265,"parent_id":255,"cat_name":"北京","cat_logo":null,"cat_path":",254,255,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":266,"parent_id":255,"cat_name":"山西","cat_logo":null,"cat_path":",254,255,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":267,"parent_id":255,"cat_name":"福建","cat_logo":null,"cat_path":",254,255,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":268,"parent_id":255,"cat_name":"其他","cat_logo":null,"cat_path":",254,255,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]},{"cat_id":256,"parent_id":254,"cat_name":"生鲜食品","cat_logo":null,"cat_path":",254,","level":"2","is_leaf":0,"child_count":8,"order_sort":2,"lv3":[{"cat_id":269,"parent_id":256,"cat_name":"水果 蔬菜","cat_logo":null,"cat_path":",254,256,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":270,"parent_id":256,"cat_name":"海鲜 水产","cat_logo":null,"cat_path":",254,256,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":271,"parent_id":256,"cat_name":"海参","cat_logo":null,"cat_path":",254,256,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":272,"parent_id":256,"cat_name":"牛排","cat_logo":null,"cat_path":",254,256,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":273,"parent_id":256,"cat_name":"肉禽蛋奶","cat_logo":null,"cat_path":",254,256,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":274,"parent_id":256,"cat_name":"熟食腊味","cat_logo":null,"cat_path":",254,256,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":275,"parent_id":256,"cat_name":"环球美食","cat_logo":null,"cat_path":",254,256,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":276,"parent_id":256,"cat_name":"产地直供","cat_logo":null,"cat_path":",254,256,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]},{"cat_id":257,"parent_id":254,"cat_name":"休闲食品","cat_logo":null,"cat_path":",254,","level":"2","is_leaf":0,"child_count":9,"order_sort":3,"lv3":[{"cat_id":277,"parent_id":257,"cat_name":"休闲零食","cat_logo":null,"cat_path":",254,257,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":278,"parent_id":257,"cat_name":"肉干肉脯","cat_logo":null,"cat_path":",254,257,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":279,"parent_id":257,"cat_name":"坚果","cat_logo":null,"cat_path":",254,257,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":280,"parent_id":257,"cat_name":"糖果","cat_logo":null,"cat_path":",254,257,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":281,"parent_id":257,"cat_name":"巧克力","cat_logo":null,"cat_path":",254,257,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":282,"parent_id":257,"cat_name":"蜜饯","cat_logo":null,"cat_path":",254,257,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":283,"parent_id":257,"cat_name":"饼干/糕点","cat_logo":null,"cat_path":",254,257,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":284,"parent_id":257,"cat_name":"产地直供","cat_logo":null,"cat_path":",254,257,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":285,"parent_id":257,"cat_name":"其他","cat_logo":null,"cat_path":",254,257,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]},{"cat_id":258,"parent_id":254,"cat_name":"进口食品","cat_logo":null,"cat_path":",254,","level":"2","is_leaf":0,"child_count":6,"order_sort":4,"lv3":[{"cat_id":386,"parent_id":258,"cat_name":"酒水饮料","cat_logo":null,"cat_path":",254,258,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":286,"parent_id":258,"cat_name":"牛奶","cat_logo":null,"cat_path":",254,258,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":287,"parent_id":258,"cat_name":"饼干蛋糕","cat_logo":null,"cat_path":",254,258,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":288,"parent_id":258,"cat_name":"休闲零食","cat_logo":null,"cat_path":",254,258,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":289,"parent_id":258,"cat_name":"巧克力","cat_logo":null,"cat_path":",254,258,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":290,"parent_id":258,"cat_name":"冲调饮品","cat_logo":null,"cat_path":",254,258,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]},{"cat_id":259,"parent_id":254,"cat_name":"油盐酱醋","cat_logo":null,"cat_path":",254,","level":"2","is_leaf":0,"child_count":8,"order_sort":5,"lv3":[{"cat_id":291,"parent_id":259,"cat_name":"食用油","cat_logo":null,"cat_path":",254,259,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":292,"parent_id":259,"cat_name":"橄榄油","cat_logo":null,"cat_path":",254,259,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":293,"parent_id":259,"cat_name":"酱油","cat_logo":null,"cat_path":",254,259,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":294,"parent_id":259,"cat_name":"醋","cat_logo":null,"cat_path":",254,259,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":295,"parent_id":259,"cat_name":"食用盐","cat_logo":null,"cat_path":",254,259,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":296,"parent_id":259,"cat_name":"调料粉","cat_logo":null,"cat_path":",254,259,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":297,"parent_id":259,"cat_name":"糖","cat_logo":null,"cat_path":",254,259,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":298,"parent_id":259,"cat_name":"麻油","cat_logo":null,"cat_path":",254,259,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]}]},{"cat_id":299,"parent_id":0,"cat_name":"运动户外","cat_logo":"","cat_path":",","level":"1","is_leaf":0,"child_count":4,"order_sort":8,"lv2":[{"cat_id":300,"parent_id":299,"cat_name":"运动跑鞋","cat_logo":null,"cat_path":",299,","level":"2","is_leaf":0,"child_count":7,"order_sort":1,"lv3":[{"cat_id":304,"parent_id":300,"cat_name":"跑步鞋","cat_logo":null,"cat_path":",299,300,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":305,"parent_id":300,"cat_name":"板鞋","cat_logo":null,"cat_path":",299,300,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":306,"parent_id":300,"cat_name":"篮球鞋","cat_logo":null,"cat_path":",299,300,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":307,"parent_id":300,"cat_name":"球鞋","cat_logo":null,"cat_path":",299,300,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":308,"parent_id":300,"cat_name":"网球鞋","cat_logo":null,"cat_path":",299,300,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":309,"parent_id":300,"cat_name":"羽毛球鞋","cat_logo":null,"cat_path":",299,300,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":310,"parent_id":300,"cat_name":"训练鞋","cat_logo":null,"cat_path":",299,300,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]},{"cat_id":301,"parent_id":299,"cat_name":"运动服饰","cat_logo":null,"cat_path":",299,","level":"2","is_leaf":0,"child_count":4,"order_sort":2,"lv3":[{"cat_id":313,"parent_id":301,"cat_name":"T恤","cat_logo":null,"cat_path":",299,301,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":314,"parent_id":301,"cat_name":"卫衣","cat_logo":null,"cat_path":",299,301,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":315,"parent_id":301,"cat_name":"运动背心","cat_logo":null,"cat_path":",299,301,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":316,"parent_id":301,"cat_name":"运动套装","cat_logo":null,"cat_path":",299,301,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]},{"cat_id":302,"parent_id":299,"cat_name":"骑行装备","cat_logo":null,"cat_path":",299,","level":"2","is_leaf":0,"child_count":4,"order_sort":3,"lv3":[{"cat_id":317,"parent_id":302,"cat_name":"山地车/公路车","cat_logo":null,"cat_path":",299,302,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":318,"parent_id":302,"cat_name":"折叠车","cat_logo":null,"cat_path":",299,302,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":319,"parent_id":302,"cat_name":"电动车","cat_logo":null,"cat_path":",299,302,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":320,"parent_id":302,"cat_name":"骑行服","cat_logo":null,"cat_path":",299,302,","level":"3","is_leaf":1,"child_count":0,"order_sort":0}]},{"cat_id":303,"parent_id":299,"cat_name":"户外装备","cat_logo":null,"cat_path":",299,","level":"2","is_leaf":0,"child_count":9,"order_sort":4,"lv3":[{"cat_id":321,"parent_id":303,"cat_name":"背包","cat_logo":null,"cat_path":",299,303,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":322,"parent_id":303,"cat_name":"帐篷","cat_logo":null,"cat_path":",299,303,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":323,"parent_id":303,"cat_name":"睡袋","cat_logo":null,"cat_path":",299,303,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":324,"parent_id":303,"cat_name":"登山攀岩","cat_logo":null,"cat_path":",299,303,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":325,"parent_id":303,"cat_name":"户外照明","cat_logo":null,"cat_path":",299,303,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":326,"parent_id":303,"cat_name":"望远镜","cat_logo":null,"cat_path":",299,303,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":327,"parent_id":303,"cat_name":"滑雪装备","cat_logo":null,"cat_path":",299,303,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":328,"parent_id":303,"cat_name":"极限户外","cat_logo":null,"cat_path":",299,303,","level":"3","is_leaf":1,"child_count":0,"order_sort":1},{"cat_id":329,"parent_id":303,"cat_name":"其他","cat_logo":null,"cat_path":",299,303,","level":"3","is_leaf":1,"child_count":0,"order_sort":1}]}]},{"cat_id":330,"parent_id":0,"cat_name":"家居用品","cat_logo":"","cat_path":",","level":"1","is_leaf":0,"child_count":5,"order_sort":9,"lv2":[{"cat_id":331,"parent_id":330,"cat_name":"家装软饰","cat_logo":null,"cat_path":",330,","level":"2","is_leaf":0,"child_count":6,"order_sort":1,"lv3":[{"cat_id":336,"parent_id":331,"cat_name":"桌布/罩件","cat_logo":null,"cat_path":",330,331,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":337,"parent_id":331,"cat_name":"地毯地垫","cat_logo":null,"cat_path":",330,331,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":338,"parent_id":331,"cat_name":"沙发垫套/椅垫","cat_logo":null,"cat_path":",330,331,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":339,"parent_id":331,"cat_name":"节庆装饰","cat_logo":null,"cat_path":",330,331,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":340,"parent_id":331,"cat_name":"手工/十字绣","cat_logo":null,"cat_path":",330,331,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":341,"parent_id":331,"cat_name":"钟饰","cat_logo":null,"cat_path":",330,331,","level":"3","is_leaf":1,"child_count":0,"order_sort":0}]},{"cat_id":332,"parent_id":330,"cat_name":"灯具","cat_logo":null,"cat_path":",330,","level":"2","is_leaf":0,"child_count":6,"order_sort":2,"lv3":[{"cat_id":342,"parent_id":332,"cat_name":"台灯","cat_logo":null,"cat_path":",330,332,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":343,"parent_id":332,"cat_name":"吸顶灯","cat_logo":null,"cat_path":",330,332,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":344,"parent_id":332,"cat_name":"LED灯","cat_logo":null,"cat_path":",330,332,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":345,"parent_id":332,"cat_name":"节能灯","cat_logo":null,"cat_path":",330,332,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":346,"parent_id":332,"cat_name":"落地灯","cat_logo":null,"cat_path":",330,332,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":347,"parent_id":332,"cat_name":"应急灯/手灯","cat_logo":null,"cat_path":",330,332,","level":"3","is_leaf":1,"child_count":0,"order_sort":0}]},{"cat_id":333,"parent_id":330,"cat_name":"厨房用具","cat_logo":null,"cat_path":",330,","level":"2","is_leaf":0,"child_count":5,"order_sort":3,"lv3":[{"cat_id":348,"parent_id":333,"cat_name":"锅具","cat_logo":null,"cat_path":",330,333,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":349,"parent_id":333,"cat_name":"刀具/菜板","cat_logo":null,"cat_path":",330,333,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":350,"parent_id":333,"cat_name":"餐具","cat_logo":null,"cat_path":",330,333,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":351,"parent_id":333,"cat_name":"杯具","cat_logo":null,"cat_path":",330,333,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":352,"parent_id":333,"cat_name":"配件","cat_logo":null,"cat_path":",330,333,","level":"3","is_leaf":1,"child_count":0,"order_sort":0}]},{"cat_id":334,"parent_id":330,"cat_name":"生活用品","cat_logo":null,"cat_path":",330,","level":"2","is_leaf":0,"child_count":5,"order_sort":4,"lv3":[{"cat_id":353,"parent_id":334,"cat_name":"收纳用品","cat_logo":null,"cat_path":",330,334,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":354,"parent_id":334,"cat_name":"雨具伞具","cat_logo":null,"cat_path":",330,334,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":355,"parent_id":334,"cat_name":"浴室用品","cat_logo":null,"cat_path":",330,334,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":356,"parent_id":334,"cat_name":"洗晒用品","cat_logo":null,"cat_path":",330,334,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":357,"parent_id":334,"cat_name":"净化出味","cat_logo":null,"cat_path":",330,334,","level":"3","is_leaf":1,"child_count":0,"order_sort":0}]},{"cat_id":335,"parent_id":330,"cat_name":"家具","cat_logo":null,"cat_path":",330,","level":"2","is_leaf":0,"child_count":5,"order_sort":5,"lv3":[{"cat_id":358,"parent_id":335,"cat_name":"卧室家具","cat_logo":null,"cat_path":",330,335,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":359,"parent_id":335,"cat_name":"客厅家具","cat_logo":null,"cat_path":",330,335,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":360,"parent_id":335,"cat_name":"餐厅家具","cat_logo":null,"cat_path":",330,335,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":361,"parent_id":335,"cat_name":"储物","cat_logo":null,"cat_path":",330,335,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":362,"parent_id":335,"cat_name":"办公","cat_logo":null,"cat_path":",330,335,","level":"3","is_leaf":1,"child_count":0,"order_sort":0}]}]},{"cat_id":363,"parent_id":0,"cat_name":"营养保健","cat_logo":"","cat_path":",","level":"1","is_leaf":0,"child_count":2,"order_sort":10,"lv2":[{"cat_id":364,"parent_id":363,"cat_name":"营养健康","cat_logo":null,"cat_path":",363,","level":"2","is_leaf":0,"child_count":6,"order_sort":1,"lv3":[{"cat_id":366,"parent_id":364,"cat_name":"调节免疫","cat_logo":null,"cat_path":",363,364,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":367,"parent_id":364,"cat_name":"调节三高","cat_logo":null,"cat_path":",363,364,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":368,"parent_id":364,"cat_name":"缓解疲劳","cat_logo":null,"cat_path":",363,364,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":369,"parent_id":364,"cat_name":"肝肾护养","cat_logo":null,"cat_path":",363,364,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":370,"parent_id":364,"cat_name":"肠胃养护","cat_logo":null,"cat_path":",363,364,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":371,"parent_id":364,"cat_name":"明目益智","cat_logo":null,"cat_path":",363,364,","level":"3","is_leaf":1,"child_count":0,"order_sort":0}]},{"cat_id":365,"parent_id":363,"cat_name":"成人用品","cat_logo":null,"cat_path":",363,","level":"2","is_leaf":0,"child_count":4,"order_sort":2,"lv3":[{"cat_id":372,"parent_id":365,"cat_name":"安全避孕","cat_logo":null,"cat_path":",363,365,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":373,"parent_id":365,"cat_name":"验孕测孕","cat_logo":null,"cat_path":",363,365,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":374,"parent_id":365,"cat_name":"人体润滑","cat_logo":null,"cat_path":",363,365,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":375,"parent_id":365,"cat_name":"情爱用具","cat_logo":null,"cat_path":",363,365,","level":"3","is_leaf":1,"child_count":0,"order_sort":0}]}]},{"cat_id":388,"parent_id":0,"cat_name":"Shopex","cat_logo":"","cat_path":",","level":"1","is_leaf":0,"child_count":1,"order_sort":11,"lv2":[{"cat_id":389,"parent_id":388,"cat_name":"ONex","cat_logo":null,"cat_path":",388,","level":"2","is_leaf":0,"child_count":5,"order_sort":1,"lv3":[{"cat_id":390,"parent_id":389,"cat_name":"B2B2C","cat_logo":null,"cat_path":",388,389,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":391,"parent_id":389,"cat_name":"B2C","cat_logo":null,"cat_path":",388,389,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":392,"parent_id":389,"cat_name":"O2O","cat_logo":null,"cat_path":",388,389,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":393,"parent_id":389,"cat_name":"CRM","cat_logo":null,"cat_path":",388,389,","level":"3","is_leaf":1,"child_count":0,"order_sort":0},{"cat_id":394,"parent_id":389,"cat_name":"OMS","cat_logo":null,"cat_path":",388,389,","level":"3","is_leaf":1,"child_count":0,"order_sort":0}]}]}]}}';
    }

}
